unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Buttons;

type

  TMouseIconState = (misNormal, misDisabled, misHot);

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ImageList1: TImageList;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure BitBtn1MouseEnter(Sender: TObject);
    procedure BitBtn1MouseLeave(Sender: TObject);
    procedure BitBtn2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    procedure MouseIconHandler(Sender: TObject; State: TMouseIconState);

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.MouseIconHandler(Sender: TObject; State: TMouseIconState);
begin
  if Sender is TSpeedButton then
    TSpeedButton(Sender).ImageIndex := TSpeedButton(Sender).Tag + ord(State)
  else
  if Sender is TBitBtn then
    TBitBtn(Sender).ImageIndex := TBitBtn(Sender).Tag + ord(State);
end;

procedure TForm1.BitBtn1MouseEnter(Sender: TObject);
begin
  if TControl(Sender).Enabled then
    MouseIconHandler(Sender, misHot)
  else
    MouseIconHandler(Sender, misDisabled);
end;

procedure TForm1.BitBtn1MouseLeave(Sender: TObject);
begin
  if TControl(Sender).Enabled then
    MouseIconHandler(Sender, misNormal)
  else
    MouseIconHandler(Sender, misDisabled);
end;

procedure TForm1.BitBtn2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if TControl(Sender).Enabled then
    MouseIconHandler(Sender, misHot)
  else
    MouseIconHandler(Sender, misDisabled);
end;

procedure TForm1.BitBtn2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if TControl(Sender).Enabled then
    MouseIconHandler(Sender, misHot)
  else
    MouseIconHandler(Sender, misDisabled);
end;


end.

